/*
 * NoCoincideLongitudoTipoCampoAlfanumericoNumericoObligatorioDependiente.java
 *
 * Created on 20 de marzo de 2007, 11:13 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.fidufosyga.rules;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import com.fidufosyga.rules.util.ValidarFecha;

/**
 * 
 * @author Julian
 */
public class NoCoincideLongitudoTipoCampoAlfanumericoNumericoObligatorioDependienteValidaCero
		extends AbstractRule {

	private Pattern pattern;

	public NoCoincideLongitudoTipoCampoAlfanumericoNumericoObligatorioDependienteValidaCero() {
		String patternStr = "[^A-Z0-9/Ñ]";
		pattern = Pattern.compile(patternStr);

	}

	public boolean performValidation(String field, String registro[],
			String nombreArchivo) {

		if (registro[new Integer((String) getParams()[0]).intValue()]
				.equals(getParams()[1])) {
			if (field.length() < new Integer((String) getParams()[2])
					.intValue()
					|| field.length() > new Integer((String) getParams()[3])
							.intValue())
			// EACG.30/03/2009.INI.A19115.Ajustes Malla Validadora, valida
			// Inicio Cero.
			{
				return true;
			} else {
				if (field.length() > 0) {
					String FechaNacimiento = registro[new Integer(
							(String) getParams()[4])];
					if (!ValidarFecha.esFecha(FechaNacimiento))
						return false;
					Integer AnnoNacimiento = new Integer(
							(FechaNacimiento.substring(6)));
					if (AnnoNacimiento >= 2000)
						if ((field.charAt(0) == ('0')
								|| (field.substring(0, 2)).compareTo("00") == 0 || (field
								.substring(0, 3)).compareTo("000") == 0))
							return false;
				}
			}
			// return true;
			// EACG.30/03/2009.FIN.A19115.
			Matcher matcher = pattern.matcher(field);
			return matcher.find();

		}

		return false;
	}

}
